<?php
	$env_handler = strtolower(getenv("MYSQLND_QC_HANDLER") ? getenv("MYSQLND_QC_HANDLER") : "default");

	$available_handler = array();
	$handler = mysqlnd_qc_get_handler();
	foreach ($handler as $k => $v)
		$available_handler[strtolower($k)] = $k;

	switch ($env_handler) {
		case "userp":
			require_once("connect.inc");
			include_once("user_handler_helper.inc");
			uh_set_mode(MYSQLND_QC_UH_MODE_PERSISTENT);
			ini_set("memory_limit", "256M");
			if (true !== ($tmp = mysqlnd_qc_set_user_handlers("get_hash", "find", "return_to_cache", "add", "is_select", "update_stats", "get_stats", "clear_cache")))
				printf("[h001] '%s' handler rejected, got %s\n", $env_handler, var_export($tmp, true));
			break;
		case "user":
			include_once("user_handler_helper.inc");
			uh_set_mode(MYSQLND_QC_UH_MODE_NON_PERSISTENT);
			ini_set("memory_limit", "256M");
			if (true !== ($tmp = mysqlnd_qc_set_user_handlers("get_hash", "find", "return_to_cache", "add", "is_select", "update_stats", "get_stats", "clear_cache")))
				printf("[h002] '%s' handler rejected, got %s\n", $env_handler, var_export($tmp, true));
			break;

		default:
			if (!isset($available_handler[$env_handler]))
				die(sprintf("skip Handler '%s' not available. Environment variable MYSQLND_QC_HANDLER set to '%s'.", $env_handler, getenv("MYSQLND_QC_HANDLER")));

			if (true !== ($tmp = mysqlnd_qc_change_handler($env_handler)))
				printf("[h003] '%s' handler rejected, got %s\n", $env_handler, var_export($tmp, true));
			break;
	}
?>